Rem    NAME
Rem      7225_10_10.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the generation of identifier reports for a function
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_10_10.sql**************
Conn ORADEV/ORADEV

--Create the function--
CREATE OR REPLACE FUNCTION F_GET_LOC (P_EMPNO NUMBER)
RETURN NUMBER
IS

--Cursor select location for the given employee--
CURSOR C_DEPT IS
  SELECT d.loc
  FROM employees e, departments d
  WHERE e.deptno = d.deptno
  AND e.empno = P_EMPNO;
l_loc NUMBER;

BEGIN
--Cursor is open and fetched into a local variable--
  OPEN C_DEPT;
  FETCH C_DEPT INTO l_loc;
  CLOSE C_DEPT;

--Location returned--
  RETURN l_loc;
END;
/
SELECT name, type, object_name, usage
FROM user_identifiers
WHERE object_name='F_GET_LOC'
/
ALTER FUNCTION F_GET_LOC COMPILE PLSCOPE_SETTINGS='IDENTIFIERS:ALL'
/
WITH v AS
 (SELECT    Line,
            Col,
            INITCAP(NAME) Name,
            LOWER(TYPE)   Type,
            LOWER(USAGE)  Usage,
            USAGE_ID, USAGE_CONTEXT_ID
  FROM USER_IDENTIFIERS
  WHERE Object_Name = 'F_GET_LOC'
    AND Object_Type = 'FUNCTION'  )
    SELECT LINE, RPAD(LPAD(' ', 2*(Level-1)) ||Name, 20, '.')||' '||
                 RPAD(Type, 20)|| RPAD(Usage, 20)
                 IDENTIFIER_USAGE_CONTEXTS
    FROM v
    START WITH USAGE_CONTEXT_ID = 0
    CONNECT BY PRIOR USAGE_ID = USAGE_CONTEXT_ID
    ORDER SIBLINGS BY Line, Col
/
