Rem    NAME
Rem      7225_11_01.sql
Rem
Rem    DESCRIPTION
Rem      The script creates the trace log table PLSQL_TRACE_RUNS and PLSQL_TRACE_EVENTS in SYS user. It creates their public synonyms and grants required privileges to the ORADEV user
Rem
Rem    NOTES
Rem      The script must be executed after running \ORACLE_HOME\rdbms\admin\tracetab.sql 

PROMPT **************Executing 7225_11_01.sql**************
--Connect as SYSDBA--
Conn sys/system as SYSDBA
--Execute \ORACLE_HOME\rdbms\admin\tracetab.sql
--Create synonym for PLSQL_TRACE_RUNS--
CREATE PUBLIC SYNONYM plsql_trace_runs FOR plsql_trace_runs
/
--Create synonym for PLSQL_TRACE_EVENTS--
CREATE PUBLIC SYNONYM plsql_trace_events FOR plsql_trace_events
/
--Create synonym for PLSQL_TRACE_RUNNUMBER sequence--
CREATE PUBLIC SYNONYM plsql_trace_runnumber FOR plsql_trace_runnumber
/
--Grant privileges on the PLSQL_TRACE_RUNS--
GRANT select, insert, update, delete ON plsql_trace_runs TO PUBLIC
/
--Grant privileges on the PLSQL_TRACE_EVENTS--
GRANT select, insert, update, delete ON plsql_trace_events TO PUBLIC
/
--Grant privileges on the PLSQL_TRACE_RUNNUMBER--
GRANT select ON plsql_trace_runnumber TO PUBLIC
/