Rem    NAME
Rem      7225_11_02.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the PL/SQL tracing feature. It starts the tracing session and stops it.
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_11_02.sql**************
Conn ORADEV/ORADEV
--Create the function--
CREATE OR REPLACE FUNCTION F_GET_LOC (P_EMPNO NUMBER)
RETURN VARCHAR2
IS

--Cursor select location for the given employee--
CURSOR C_DEPT IS
  SELECT d.loc
  FROM employees e, departments d
  WHERE e.deptno = d.deptno
  AND e.empno = P_EMPNO;
l_loc VARCHAR2(100);

BEGIN
--Cursor is open and fetched into a local variable--
  OPEN C_DEPT;
  FETCH C_DEPT INTO l_loc;
  CLOSE C_DEPT;

--Location returned--
  RETURN l_loc;
END;
/
ALTER FUNCTION F_GET_LOC COMPILE DEBUG
/
BEGIN
--Enable tracing for all calls in the session--
   DBMS_TRACE.SET_PLSQL_TRACE(DBMS_TRACE.TRACE_ALL_CALLS);
END;
/
VARIABLE M_LOC VARCHAR2(100)
EXEC :M_LOC := F_GET_LOC (7369)
PRINT M_LOC
BEGIN
--Stop the trace session--
   DBMS_TRACE.CLEAR_PLSQL_TRACE;
END;
/
