Rem    NAME
Rem      7225_12_02.sql
Rem
Rem    DESCRIPTION
Rem      The script shows the sql injection in a procedure which is owned by SYS and executed by other users using the creator's rights.
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_12_02.sql**************
--Connect as SYSDBA--
Conn sys/system as SYSDBA

--Enable the SERVEROUTPUT to display the messages--
SET SERVEROUTPUT ON

--Create the procedure to alter the tablespace--
CREATE OR REPLACE PROCEDURE p_mod_tablespace
(P_USERNAME VARCHAR2 DEFAULT NULL,
 P_TABLESPACE VARCHAR2 DEFAULT NULL)
IS
  V_STMT VARCHAR2(500);
BEGIN

--Dynamically alter the user to modify default tablespace--
  V_STMT:='ALTER USER '||p_username ||
		 ' default tablespace '|| P_TABLESPACE;

--Execute the dynamic statement--
  EXECUTE IMMEDIATE v_stmt;
END p_mod_tablespace;
/
GRANT execute ON p_mod_tablespace TO ORADEV
/
CONN ORADEV/ORADEV
ALTER USER nancy DEFAULT TABLESPACE system
/
--Connect to ORADEV user--
Conn ORADEV/ORADEV

--Enable the SERVEROUTPUT to display the messages--
SET SERVEROUTPUT ON
EXEC SYS.P_MOD_TABLESPACE ('NANCY','SYSTEM')
Conn / as sysdba
SELECT username, default_tablespace
FROM dba_users
WHERE username='NANCY'
/
