Rem    NAME
Rem      7225_12_05.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the usage of bind arguments to avoid SQL injection in PL/SQL code
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_12_05.sql**************
--Connect to ORADEV user--
Conn ORADEV/ORADEV

--Enable the SERVEROUTPUT to display the messages--
SET SERVEROUTPUT ON

--Create the procedure--
CREATE OR REPLACE PROCEDURE P_SHOW_DEPT
(P_ENAME VARCHAR2)
IS
   CUR SYS_REFCURSOR;
   l_ename VARCHAR2(100);
   l_deptno NUMBER;
BEGIN

--Open ref cursor for a dynamic query using a bind variable--
   OPEN CUR FOR 'SELECT ename, deptno
                 FROM employees
                 WHERE ename = :bind' USING P_ENAME;
   LOOP

--Fetch and display the results--
   FETCH CUR INTO l_ename, l_deptno;
   EXIT WHEN cur%notfound;
      DBMS_OUTPUT.PUT_LINE(l_ename ||'--'|| l_deptno);
   END LOOP;
END;
/
EXEC p_show_dept ('KING')
EXEC P_SHOW_DEPT ('null UNION SELECT ENAME, SAL FROM EMPLOYEES')
