Rem    NAME
Rem      7225_02_02.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the working of explicit cursors in PL/SQL. It lists the details of top 2 salary takes from the orgranisation.
Rem
Rem    NOTES
Rem      None
PROMPT **************Executing 7225_02_02.sql**************
--Enable the SERVEROUTPUT parameter to print the results in the environment--
SET SERVEROUTPUT ON

DECLARE
--Declare a cursor to select top 2 highest paid employees--
   CURSOR cur_emp
   IS
      SELECT empno, ename, hiredate, sal
      FROM
      (SELECT empno, ename, hiredate, sal,
              ROW_NUMBER() OVER (PARTITION BY 1 ORDER BY sal DESC) RN
       FROM employees)
      WHERE RN < 3;

   l_empno employees.empno%TYPE;
   l_ename employees.ename%TYPE;
   l_doj employees.hiredate%TYPE;
   l_sal employees.sal%TYPE;
BEGIN
--Open the cursor--
   OPEN cur_emp;
   LOOP

--Fetch the cursor select column list into local variables--
      FETCH cur_emp INTO l_empno, l_ename, l_doj, l_sal;
      EXIT WHEN cur_emp%NOTFOUND;
      DBMS_OUTPUT.PUT_LINE('Employee details for '||l_ename);
      DBMS_OUTPUT.PUT_LINE('Employee Number: '||l_empno);
      DBMS_OUTPUT.PUT_LINE('Date of joining: '||l_doj);
      DBMS_OUTPUT.PUT_LINE('Salary: '||l_sal);
      DBMS_OUTPUT.PUT_LINE(CHR(10));
   END LOOP;
--Close the cursor--
   CLOSE cur_emp;
END;
/
