Rem    NAME
Rem      7225_02_05.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the usage of cursor variables as arguments in oracle subprograms.
Rem
Rem    NOTES
Rem      None
PROMPT **************Executing 7225_02_05.sql**************
--Enable the SERVEROUTPUT parameter to print the results in the environment--
SET SERVEROUTPUT ON
--Create the procedure to demonstrate cursor variable in parameter list--
CREATE OR REPLACE PROCEDURE 
p_emp_location (p_emp_data OUT SYS_REFCURSOR)
IS

--Declare a local ref cursor variable--
   TYPE cur_emp_rf IS REF CURSOR;
   cur_emp_loc cur_emp_rf;
BEGIN

--Open the local ref cursor variable for the SELECT query--
   OPEN cur_emp_loc FOR SELECT e.ename, d.loc
                        FROM employees e, departments d
                        WHERE e.deptno = d.deptno;
--Assign the cursor OUT parameter with the local cursor variable--
   p_emp_data := cur_emp_loc;
END;   
/
VARIABLE M_EMP_LOC REFCURSOR
/
EXEC P_EMP_LOCATION(:M_EMP_LOC)
/
PRINT M_EMP_LOC
/