Rem    NAME
Rem      7225_03_03.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the working of Nested table type in database
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_03_03.sql**************
PROMPT Creating the nested table collection type.....
CREATE TYPE NUM_NEST_T AS TABLE OF NUMBER;
/
PROMPT Display the collection type metadata from USER_TYPES and USER_COLL_TYPES.....
SELECT type_name, typecode, type_oid
FROM USER_TYPES
WHERE type_name = 'NUM_NEST_T'
/
SELECT type_name, coll_type, elem_type_name
FROM user_coll_types
WHERE type_name = 'NUM_NEST_T'
/
PROMPT Creating a table with a nested table type column.....
CREATE TABLE TAB_USE_NT_COL
     (ID NUMBER,
      NUM NUM_NEST_T)
          NESTED TABLE NUM STORE AS NESTED_NUM_ID
/
PROMPT Inserting sample data.....
INSERT INTO TAB_USE_NT_COL (ID, NUM)
VALUES 
(1, NUM_NEST_T(10,12,3))
/
INSERT INTO TAB_USE_NT_COL (ID, NUM)
VALUES 
(2, NUM_NEST_T(23,43))
/
PROMPT Query the table with nested table instances.....
SELECT *  FROM tab_use_nt_col
/
PROMPT Query the table with nested table instances in relational format.....
SELECT T.id, T1.column_value 
     FROM tab_use_nt_col T, TABLE (T.num) T1
/
commit
/
PROMPT Update the nested table instance for second parent row.....
UPDATE tab_use_nt_col
SET num = num_nest_t(10,12,13)
WHERE id=2
/
PROMPT Verify the update operation.....
SELECT * FROM tab_use_nt_col
/
PROMPT Update the single element of nested table instance using TABLE expression.....
UPDATE TABLE (SELECT num FROM tab_use_nt_col WHERE id = 1)  P
SET P.COLUMN_VALUE = 100
WHERE P.COLUMN_VALUE = 12
/
PROMPT Verify the update operation.....
SELECT * FROM TAB_USE_NT_COL
/
