Rem    NAME
Rem      7225_05_04.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the VPD implementation with application contexts
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_05_04.sql**************
conn sys/system as sysdba
grant create any context to oradev
/
conn ORADEV/ORADEV
CREATE CONTEXT EMPLOYEES USING PKG_CONTEXTS
/
CREATE OR REPLACE PACKAGE PKG_CONTEXTS IS
   /*Prototype the procedure to set the context*/
   PROCEDURE P_SET_CONTEXT (P_DEPT NUMBER);
END;
/
CREATE OR REPLACE PACKAGE BODY PKG_CONTEXTS IS
    /*Define the procedure to set the context*/
    PROCEDURE P_SET_CONTEXT (P_DEPT NUMBER)
    IS
    BEGIN
     /*Use DBMS_SESSION to set the content of DEPARTMENT namespace*/
       dbms_session.set_context(namespace => 'EMPLOYEES',
                                attribute => 'DEPARTMENT' ,
                                value     =>  P_DEPT);
   END;
END;
/
Conn sys/system as sysdba
/*Create LOGON trigger to set the context as soon as a user logs in*/
CREATE OR REPLACE TRIGGER ON_LOGON
/*Specify the event of trigger firing as AFTER LOGON*/
AFTER LOGON ON DATABASE
BEGIN
/*Invoke the policy function from the ORADEV user */
   ORADEV.PKG_CONTEXTS.P_SET_CONTEXT(20);
END;
/
conn ORADEV/ORADEV
SELECT SYS_CONTEXT('EMPLOYEES','DEPARTMENT') FROM DUAL
/
conn ORADEV/ORADEV
CREATE OR REPLACE FUNCTION f_get_dept_predicate(p_schema varchar2,
                                                p_obj varchar2)
RETURN VARCHAR2 IS
BEGIN
/*Return the predicate using SYS_CONTEXT*/
   RETURN 'deptno = SYS_CONTEXT(''EMPLOYEES'', ''DEPARTMENT'')';
END;
/
BEGIN
DBMS_RLS.ADD_POLICY 
(
object_schema => 'ORADEV',
object_name => 'EMPLOYEES',
policy_name => 'EMP_DEPT_20',
function_schema => 'ORADEV',
policy_function => 'F_GET_DEPT_PREDICATE',
statement_types => 'select, insert, update, delete'
);
END;
/
SELECT * FROM employees
/
SELECT policy_name, 
            Policy_type, 
            Static_policy, 
            function, 
            pf_owner 
FROM USER_POLICIES
/
SELECT * FROM ALL_CONTEXT
/
EXEC DBMS_RLS.REFRESH_POLICY('ORADEV','EMPLOYEES','EMP_DEPT_20')
/
EXEC DBMS_RLS.DROP_POLICY('ORADEV','EMPLOYEES','EMP_DEPT_20')
/
