Rem    NAME
Rem      7225_06_07.sql
Rem
Rem    DESCRIPTION
Rem      The script populates the data from external files into the LOB columns
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_06_07.sql**************
Conn ORADEV/ORADEV
--Enable the SERVEROUTPUT to display the block messages--
SET SERVEROUTPUT ON

--Start the PL/SQL block--
DECLARE

--Declaring LOB locator for CLOB and BLOB--
  L_SOURCE_CLOB BFILE := BFILENAME('LOB_DIR', 'LOB_data_file.txt');
  L_SOURCE_BLOB BFILE := BFILENAME('LOB_DIR', 'MyLogo.JPG');

--Declaring offset value for both LOB columns--
  L_AMT_CLOB  INTEGER := 4000;
  L_AMT_BLOB  INTEGER := 4000;

--Declaring temporary LOB columns for both LOB columns--
  L_CLOB CLOB := EMPTY_CLOB();
  L_BLOB BLOB := EMPTY_BLOB();
BEGIN

--Opening the LOB locator in read only mode--
  DBMS_LOB.OPEN(L_SOURCE_CLOB, DBMS_LOB.LOB_READONLY);
  DBMS_LOB.OPEN(L_SOURCE_BLOB, DBMS_LOB.LOB_READONLY);

--Calculating the length of LOB locator--
  L_AMT_CLOB := DBMS_LOB.GETLENGTH(L_SOURCE_CLOB);
  L_AMT_BLOB := DBMS_LOB.GETLENGTH(L_SOURCE_BLOB);

--Create the record into LOB_DEMO table with empty LOB instance in both CLOB and BLOB. Fetch the LOB column values into temporary LOB variables--  
  INSERT INTO emp_lob_demo
  VALUES (7369, EMPTY_CLOB, EMPTY_BLOB())
  RETURNING DOC,IMAGE INTO L_CLOB, L_BLOB;

--Load the temporary LOBs with the LOB locator and object pointed by them--
  DBMS_OUTPUT.PUT_LINE('Inserting text file into database. . .');
  DBMS_LOB.LOADFROMFILE(L_CLOB, L_SOURCE_CLOB, L_AMT_CLOB);
  DBMS_OUTPUT.PUT_LINE('Populating CLOB data is over');
  DBMS_OUTPUT.PUT_LINE('Inserting Image file into database. . .');
  DBMS_LOB.LOADFROMFILE(L_BLOB, L_SOURCE_BLOB, L_AMT_BLOB);
  DBMS_OUTPUT.PUT_LINE('Populating BLOB data is over');

--Close the LOB locators--
  DBMS_LOB.CLOSE(L_SOURCE_CLOB);
  DBMS_LOB.CLOSE(L_SOURCE_BLOB);

--Update the emp_lob_demo with the temporary LOB variable values--
  UPDATE emp_lob_demo
  SET doc   = L_CLOB, 
      image = L_BLOB
  WHERE empid = 7369;
END;
/
SELECT * FROM emp_lob_demo 
     WHERE empid = 7369
/