Rem    NAME
Rem      7225_06_14.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the working with Temporary LOBs
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_06_14.sql**************
conn ORADEV/ORADEV
--Enable the SERVEROUT to display the block output--
SET SERVEROUTPUT ON
--Start the PL/SQL block--
DECLARE
  L_TEMP_LOB CLOB;
  AMT NUMBER;
  OFFSET NUMBER := 5;
  L_WRITE VARCHAR2(100) := 'Oracle 8i introduced LOB types';
  L_APPEND VARCHAR2(100) := 'Oracle 11g introduced SecureFiles';
BEGIN
--Create the temporary LOB--
  DBMS_LOB.CREATETEMPORARY(lob_loc 	=> L_TEMP_LOB,
				    cache 		=> true,
 				    dur 		=> dbms_lob.session );

--Verify the creation of temporary LOB--
  IF (DBMS_LOB.ISTEMPORARY(L_TEMP_LOB) = 1) THEN
     DBMS_OUTPUT.PUT_LINE('Given LOB is a temporary LOB');
  ELSE
     DBMS_OUTPUT.PUT_LINE('Given LOB is a persistent LOB');
  END IF;

--Open the temporary LOB is read write mode--
  DBMS_LOB.OPEN(lob_loc   => L_TEMP_LOB,
		      open_mode => DBMS_LOB.LOB_READWRITE);

--Write the sample data in the temporary LOB--
  DBMS_LOB.WRITE(lob_loc  => L_TEMP_LOB,
			 amount  => LENGTH(L_WRITE),
			 offset  => OFFSET,
			 buffer  => L_WRITE );

  DBMS_OUTPUT.PUT_LINE('Temporary LOB length after Write '||DBMS_LOB.GETLENGTH(L_TEMP_LOB) );

--Append the sample in the temporary LOB--
  DBMS_LOB.WRITEAPPEND(lob_loc => L_TEMP_LOB,
				amount  => LENGTH(L_APPEND),
				buffer  => L_APPEND);

  DBMS_OUTPUT.PUT_LINE('Temporary LOB length after Append '||DBMS_LOB.GETLENGTH(L_TEMP_LOB) );

--Display the complete content of the temporary LOB--
  DBMS_OUTPUT.PUT_LINE(CHR(10)||'Temporary LOB Content: ');
  DBMS_OUTPUT.PUT_LINE(DBMS_LOB.SUBSTR(L_TEMP_LOB,DBMS_LOB.GETLENGTH(L_TEMP_LOB), 1));

  DBMS_LOB.CLOSE(lob_loc => L_TEMP_LOB);
  DBMS_LOB.FREETEMPORARY(lob_loc => L_TEMP_LOB);
END;
/
