Rem    NAME
Rem      7225_07_07.sql
Rem
Rem    DESCRIPTION
Rem      The script performs the complete migration of a BasicFile to SecureFile
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_07_07.sql**************
conn ORADEV/ORADEV
--Creating source table for migration--
CREATE TABLE ready_for_migration
(id NUMBER primary key,
 doc CLOB )
/
--Creating sample data--
INSERT INTO ready_for_migration VALUES (1, 'Oracle 9i')
/
INSERT INTO ready_for_migration VALUES (2, 'Oracle 10g')
/
INSERT INTO ready_for_migration VALUES (3, 'Oracle 11g')
/
COMMIT
/
SELECT * FROM ready_for_migration
/
--Verify the basicfile nature--
SELECT column_name, securefile
FROM user_lobs
WHERE table_name='READY_FOR_MIGRATION'
/
--Creating target table for migration--
CREATE TABLE target_for_migration
(id NUMBER,
 doc CLOB)
 LOB(doc) STORE AS SECUREFILE
 /
--Verify the securefile nature in the target table--
SELECT column_name, securefile
FROM user_lobs
WHERE table_name='TARGET_FOR_MIGRATION'
/
CONN sys/system AS SYSDBA
--Start the redefinition process--
DECLARE
L_ERROR PLS_INTEGER := 0;
BEGIN
  DBMS_REDEFINITION.START_REDEF_TABLE
  ('ORADEV', 'READY_FOR_MIGRATION', 'TARGET_FOR_MIGRATION',
  'id id,
   doc doc');

  DBMS_REDEFINITION.COPY_TABLE_DEPENDENTS
  ('ORADEV', 'READY_FOR_MIGRATION', 'TARGET_FOR_MIGRATION',1, true,true,true,false, L_ERROR);

  DBMS_OUTPUT.PUT_LINE('Errors := ' || TO_CHAR(L_ERROR));

  DBMS_REDEFINITION.FINISH_REDEF_TABLE
  ('ORADEV', 'READY_FOR_MIGRATION', 'TARGET_FOR_MIGRATION');
END;
/
--Verify the SecureFile nature in the source table--
SELECT column_name, securefile
FROM USER_LOBS
WHERE TABLE_NAME='READY_FOR_MIGRATION'
/
--Verify the data in the source table--
SELECT * FROM READY_FOR_MIGRATION
/
--Verify the basicfile nature in the target table--
SELECT column_name, securefile
FROM USER_LOBS
WHERE TABLE_NAME='TARGET_FOR_MIGRATION'
/
