Rem    NAME
Rem      7225_08_06.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the effect of NOT NULL constraints on block execution performance
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_08_06.sql**************
conn ORADEV/ORADEV
--Enable the SERVEROUTPUT to display block results-- 
SET SERVEROUTPUT ON

--Start the PL/SQL block--
DECLARE
  L_NUM  NUMBER NOT NULL := 0;
  L_A NUMBER := 10;
  L_COUNT NUMBER;
BEGIN

--Capture the start time--
  L_COUNT := DBMS_UTILITY.GET_TIME;

--Start the loop--
  FOR I IN 1..1000000
  LOOP
    L_NUM := L_A + I;
  END LOOP;

--Compute the time difference and display--
  DBMS_OUTPUT.PUT_LINE('Time Consumed:'||TO_CHAR(DBMS_UTILITY.GET_TIME - L_COUNT));
END;
/
--Start the PL/SQL block--
DECLARE
  L_NUM  NUMBER;
  L_A NUMBER := 10;
  L_COUNT NUMBER;
BEGIN

--Capture the start time--
  L_COUNT := DBMS_UTILITY.GET_TIME;

--Start the loop--
  FOR I IN 1..1000000
  LOOP
    L_NUM := L_A + I;
    IF L_NUM IS NULL THEN
       DBMS_OUTPUT.PUT_LINE('Result cannot be NULL');
       EXIT;
    END IF;
  END LOOP;

--Compute the time difference and display--
  DBMS_OUTPUT.PUT_LINE('Time Consumed:'||TO_CHAR(DBMS_UTILITY.GET_TIME - L_COUNT));
END;
/
