Rem    NAME
Rem      7225_08_11.sql
Rem
Rem    DESCRIPTION
Rem      The script illustrates the usage of FORALL in Bulk operations. The block updates the salary of employees.
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_08_11.sql**************
conn ORADEV/ORADEV
--Enable the SERVEROUTPUT to display block results-- 
SET SERVEROUTPUT ON

--Start the PL/SQL block--
DECLARE

--Declare a local record and a table of record to capture the values--
  TYPE REC_EMP IS RECORD
  (EMPID EMPLOYEES.EMPNO%TYPE,
   ENAME EMPLOYEES.ENAME%TYPE,
   DEPT EMPLOYEES.DEPTNO%TYPE,
   SALARY EMPLOYEES.SAL%TYPE);

  TYPE T_EMP IS TABLE OF REC_EMP;
  L_EMP T_EMP := T_EMP();

  TYPE REC_EMP_UPD IS RECORD
  (ENAME EMPLOYEES.ENAME%TYPE,
   SAL EMPLOYEES.SAL%TYPE);

  TYPE T_EMP_UPD IS TABLE OF REC_EMP_UPD;
  L_EMP_UPD T_EMP_UPD;
BEGIN

--Fetch the employee details in a local collection--
  SELECT empno, ename, deptno, sal
  BULK COLLECT INTO L_EMP
  FROM employees;

--Use FORALL to update the salary values. Note the use of RETURNING INTO--
  FORALL I IN L_EMP.FIRST..L_EMP.LAST
   UPDATE employees
   SET sal = L_EMP(I).SALARY + 1000
   WHERE empno = L_EMP(I).EMPID
   RETURNING ENAME, SAL BULK COLLECT INTO L_EMP_UPD;

--Display the current data--
  FOR I IN 1..L_EMP_UPD.COUNT
  LOOP
     DBMS_OUTPUT.PUT_LINE('New salary of '||L_EMP_UPD(I).ENAME||' is '||L_EMP_UPD(I).SAL);
  END LOOP;
END;
/
ROLLBACK
/