Rem    NAME
Rem      7225_08_12.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the usage of SAVE_EXCEPTIONS in bulk operations to log the exceptions in the transactions
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_08_12.sql**************
CONN ORADEV/ORADEV
--Enable the SERVEROUTPUT to display block results-- 
SET SERVEROUTPUT ON

--Start the PL/SQL block--
DECLARE

--A local PL/SQL table holds the list of new names--
  TYPE T_EMP IS TABLE OF VARCHAR2(100) ;
  L_EMP T_EMP := T_EMP('Smith','Adams',null,'King',null,'George');
  BULK_ERRORS EXCEPTION;
  PRAGMA EXCEPTION_INIT (BULK_ERRORS, -24381);
BEGIN

--FORALL to update the employee names--
FORALL I IN 1..L_EMP.COUNT
SAVE EXCEPTIONS
UPDATE EMPLOYEES
SET ENAME = L_EMP(I);
EXCEPTION

--BULK_ERRORS exception handler--
  WHEN BULK_ERRORS THEN

--Display the errors occurred during BULK DML transaction--
  FOR J IN 1..SQL%BULK_EXCEPTIONS.COUNT
  LOOP
   DBMS_OUTPUT.PUT_LINE(CHR(10));
   DBMS_OUTPUT.PUT_LINE('Error in UPDATE: '||SQL%BULK_EXCEPTIONS(J).ERROR_INDEX);
   DBMS_OUTPUT.PUT_LINE('Error Code is: '||sql%BULK_EXCEPTIONS(J).ERROR_CODE);
   DBMS_OUTPUT.PUT_LINE('Error Message is: '||sqlerrm('-'||SQL%BULK_EXCEPTIONS(J).ERROR_CODE));
  END LOOP;
END;
/
ROLLBACK
/