Rem    NAME
Rem      7225_08_18.sql
Rem
Rem    DESCRIPTION
Rem      The script demonstrates the usage of PRAGMA INLINE in Oracle subprograms 
Rem
Rem    NOTES
Rem      None

PROMPT **************Executing 7225_08_18.sql**************
--Connect as ORADEV user--
Conn ORADEV/ORADEV
ALTER SESSION SET PLSQL_OPTIMIZE_LEVEL=2
/
--Create a procedure--
CREATE OR REPLACE PROCEDURE P_SUM_SERIES(P_LIMIT NUMBER)
IS
  L_SERIES NUMBER := 0;
  L_ST_TIME NUMBER;
  L_END_TIME NUMBER;

--Declare a local function which is candidate for inlining--
  FUNCTION DUBN (P_NUM NUMBER) RETURN NUMBER IS
  BEGIN
   RETURN P_NUM * 2;
  END DUBN;
BEGIN

--Capture the start time--
  L_ST_TIME := DBMS_UTILITY.GET_TIME();

--Begin the loop for series calculation--  
  FOR J IN 1..P_LIMIT
  LOOP
--Set inlining for the local subprogram--
    PRAGMA INLINE (DUBN, 'YES');
    L_SERIES := L_SERIES + DUBN(J);
  END LOOP;

--Capture end time--  
  L_END_TIME := DBMS_UTILITY.GET_TIME();

--Display the time consumed with inlining of local function--  
  DBMS_OUTPUT.PUT_LINE('Execution time with inlining:'||TO_CHAR(L_END_TIME - L_ST_TIME));

--Repeat the steps with inlining off--  
  L_ST_TIME := DBMS_UTILITY.GET_TIME();
  
  FOR J IN 1..P_LIMIT
  LOOP

--Set off inlining for the local function--
    PRAGMA INLINE (DUBN, 'NO');
    L_SERIES := L_SERIES + DUBN(J);
  END LOOP;
  
  L_END_TIME := DBMS_UTILITY.GET_TIME();
  
  DBMS_OUTPUT.PUT_LINE('Execution time without inlining:'||TO_CHAR(L_END_TIME - L_ST_TIME));
END;
/
SET SERVEROUTPUT ON
EXEC P_SUM_SERIES (1000000)
--Select the warnings for the procedure P_SUM_SERIES--
SELECT line, text
FROM user_errors
WHERE name='P_SUM_SERIES'
/
